# Introduction

In this challenge we will add security testing to our existing pipeline

# Step 01 - Securing the Pipeline

1. First we need to get back to editing our pipeline from the last track. Make sure your still in your **_workshop-project_** space and use the left hand navigation menu to click through **Build -\> Pipeline editor** so we can edit our pipeline .yml file.
2. Under where we define the image for our pipeline we will add the below code to include the SAST template:

   ```plaintext
   include:
     - template: Security/SAST.gitlab-ci.yml
   ```
3. To take a look at the template we just added look near the top of the edit page next to where you can select the branch (branch will show **_main_** right now) there will be a **_tree expand icon_** we want to click. From here we can see a link to all of the templates we currently have included in our pipeline.
4. We then want to click the link for **Jobs/SAST.gitlab-ci.yml** that will open a new window where you can view the contents of the job we have included. Spend some time looking this over then close out the window to get back to our pipeline editor screen.
5. You can also click the **_Full configuration_** to see the complete yaml output of your .gitlab-ci.yml file plus all templates you have included.
6. Now that we have SAST lets add a few more security templates to our project to confirm that our code is secure. Edit your **_includes_** section below to be:

   ```plaintext
   include:
     - template: Code-Quality.gitlab-ci.yml
     - template: Jobs/Dependency-Scanning.gitlab-ci.yml
     - template: Jobs/SAST.gitlab-ci.yml
     - template: Jobs/Secret-Detection.gitlab-ci.yml
   ```
7. We will also now want to edit our stages to ensure we can run all of these templates:

   ```plaintext
   stages:
     - build
     - test
     - security
   ```
8. Also if you click the tree icon or **_Full configuration_** tab you should be able to see the content of all of the new security templates we have added. Before committing we will add some inheritance in the next step.

# Step 02 - Using Inheritance to Enhance Our Pipeline

1. Now we will create a new **_sast_** job that will overwrite some of the functionality from the template we included. The below code sets up the new job and has it run as soon as the pipeline begins:

   ```plaintext
   # overwrite SAST job stage and start job as soon as pipeline begins
   sast:
     stage: security
     needs: []
   ```

2. Now when we go ahead and click **Commit Changes** and use the left hand menu to click through **Build \> Pipelines**, then click the hyperlink from the most recently kicked off pipeline that starts with **<span dir="">_#_</span>**. First we can see the changes that took place by using inheritance on the **_sast_** job & we will wait for the pipeline to complete before moving on to the next step. If you got lost at any point you can just merge in the **_extended-sast_** branch as well.

   > Note that we have also added a new stage which continues to run even though our **_code_quality_** job is still failing

# Step 03 - Parsing The Results

1. Now that our pipelines have ran we want to take a look at the results from our security scanners. _Please note, if you ran the last pipeline from a different branch than main the security results will not show up_

2. Still within the pipeline view (you may have to refresh the page) there will now be a **Security** tab. Go ahead and click it. 

3. Within this view we can see all of the current security vulnerabilities effecting our branch. Click a shown vulnerability to see the benefit of GitLab's one platform where you can instantly be linked to where the vulnerability exists in code or even create an issue to start tracking the work to fix it. 

4. There will also be a **Licenses** & **Code Quality** tab for you to check out and get results based on the pipeline we just ran.

5. Next use the left hand navigation menu to click through **Secure > Vulnerability Report** to get a similar report to what was shown in the pipeline view but strickly for the main branch. There also are a number of other security reports that depending on time your presenter will cover.
